
#ifndef DATA_STRUCTURE_H
#define DATA_STRUCTURE_H

/*The structure of the list node in the adjacent list.*/
typedef struct g_node
{
	int				id;
	float			weight;
	struct g_node*	next;
} g_node_t;


/*The structure of the array head in the adjacent list.*/
typedef struct g_head
{
//	int			id;
	float		thr;
	int			tag;
	g_node_t*	head;
} g_head_t;


/*The structure of graph(social network).*/
typedef struct graph
{
	g_head_t*	head_v;
	int			size;
	int			edge_n;

} graph_t;


/*The structure the node of seed list.*/
typedef struct s_node
{
	int				id;
	struct s_node*	next;
} s_node_t;


/*The structure of the seed list.*/
typedef struct s_list
{
	s_node* s_head;
	int		size;
} s_list_t;


/*The structure for collecting statistic information.*/
typedef struct sta
{
	float	exec_time;
	float	memory_max;
	float	memory_v;

} sta_t;

/*The structure of scc.*/
typedef struct scc
{
	int		num;	//Number of SCCs.
	int		size;	//Number of nodes in the graph.
	int*	scc_arr;//SCC membership of each node.
} scc_t;
	

/*The structure of edge.*/
typedef struct edge
{
	int idx1;
	int idx2;
} edge_t;

/*The structure of edge set.*/
typedef struct edge_s
{
	int		num;
	int		size;
	edge_t*	edge_arr;
} edge_s_t;


#endif